if (!defined &_SYS_STAT_H) {
    eval 'sub _SYS_STAT_H {1;}';
    require 'sys/feature_tests.ph';
    require 'sys/time.ph';
    require 'sys/types.ph';
    if (defined &__cplusplus) {
    }
    eval 'sub _ST_FSTYPSZ {16;}';
    if (defined( &_KERNEL)) {
    }
    else {
	if ((!defined( &_POSIX_C_SOURCE) && !defined( &_XOPEN_SOURCE)) || ( &_POSIX_C_SOURCE > 2) || defined( &__EXTENSIONS__)) {
	    eval 'sub st_atime { &st_atim. &tv_sec;}';
	    eval 'sub st_mtime { &st_mtim. &tv_sec;}';
	    eval 'sub st_ctime { &st_ctim. &tv_sec;}';
	}
	else {
	    eval 'sub st_atime { &st_atim. &_tv_sec;}';
	    eval 'sub st_mtime { &st_mtim. &_tv_sec;}';
	    eval 'sub st_ctime { &st_ctim. &_tv_sec;}';
	}
    }
    eval 'sub S_IFMT {0xF000;}';
    eval 'sub S_IAMB {0x1FF;}';
    eval 'sub S_IFIFO {0x1000;}';
    eval 'sub S_IFCHR {0x2000;}';
    eval 'sub S_IFDIR {0x4000;}';
    eval 'sub S_IFNAM {0x5000;}';
    eval 'sub S_INSEM {0x1;}';
    eval 'sub S_INSHD {0x2;}';
    eval 'sub S_IFBLK {0x6000;}';
    eval 'sub S_IFREG {0x8000;}';
    eval 'sub S_IFLNK {0xA000;}';
    eval 'sub S_IFSOCK {0xC000;}';
    eval 'sub S_IFDOOR {0xD000;}';
    eval 'sub S_ISUID {0x800;}';
    eval 'sub S_ISGID {0x400;}';
    eval 'sub S_ISVTX {0x200;}';
    eval 'sub S_IREAD {00400;}';
    eval 'sub S_IWRITE {00200;}';
    eval 'sub S_IEXEC {00100;}';
    eval 'sub S_ENFMT { &S_ISGID;}';
    eval 'sub S_IRWXU {00700;}';
    eval 'sub S_IRUSR {00400;}';
    eval 'sub S_IWUSR {00200;}';
    eval 'sub S_IXUSR {00100;}';
    eval 'sub S_IRWXG {00070;}';
    eval 'sub S_IRGRP {00040;}';
    eval 'sub S_IWGRP {00020;}';
    eval 'sub S_IXGRP {00010;}';
    eval 'sub S_IRWXO {00007;}';
    eval 'sub S_IROTH {00004;}';
    eval 'sub S_IWOTH {00002;}';
    eval 'sub S_IXOTH {00001;}';
    eval 'sub S_ISFIFO {
        local($mode) = @_;
        eval "((($mode)&0xF000) == 0x1000)";
    }';
    eval 'sub S_ISCHR {
        local($mode) = @_;
        eval "((($mode)&0xF000) == 0x2000)";
    }';
    eval 'sub S_ISDIR {
        local($mode) = @_;
        eval "((($mode)&0xF000) == 0x4000)";
    }';
    eval 'sub S_ISBLK {
        local($mode) = @_;
        eval "((($mode)&0xF000) == 0x6000)";
    }';
    eval 'sub S_ISREG {
        local($mode) = @_;
        eval "((($mode)&0xF000) == 0x8000)";
    }';
    eval 'sub S_ISLNK {
        local($mode) = @_;
        eval "((($mode)&0xF000) == 0xa000)";
    }';
    eval 'sub S_ISSOCK {
        local($mode) = @_;
        eval "((($mode)&0xF000) == 0xc000)";
    }';
    eval 'sub S_ISDOOR {
        local($mode) = @_;
        eval "((($mode)&0xF000) == 0xd000)";
    }';
    eval 'sub S_TYPEISMQ {
        local($_buf) = @_;
        eval "(0)";
    }';
    eval 'sub S_TYPEISSEM {
        local($_buf) = @_;
        eval "(0)";
    }';
    eval 'sub S_TYPEISSHM {
        local($_buf) = @_;
        eval "(0)";
    }';
    eval 'sub _R3_MKNOD_VER {1;}';
    eval 'sub _MKNOD_VER {2;}';
    eval 'sub _R3_STAT_VER {1;}';
    eval 'sub _STAT_VER {2;}';
    if (!defined( &_KERNEL)) {
	if (defined( &__STDC__)) {
	    if ((!defined( &_POSIX_C_SOURCE) && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	    }
	    if (!defined( &_POSIX_C_SOURCE) && !defined( &_XOPEN_SOURCE) || ( &_POSIX_C_SOURCE > 2) || defined( &__EXTENSIONS__)) {
	    }
	    if ((!defined( &_POSIX_C_SOURCE) && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	    }
	}
	else {
	    if ((!defined( &_POSIX_C_SOURCE) && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	    }
	    if ((!defined( &_POSIX_C_SOURCE) && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	    }
	}
    }
    if (!defined( &_KERNEL)) {
	if (defined &__STDC__) {
	}
	else {
	}
	if ((!defined( &_POSIX_C_SOURCE) && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	    if (defined &__STDC__) {
	    }
	    else {
	    }
	}
	if (defined &__STDC__) {
	}
	else {
	}
	if ((!defined( &_POSIX_C_SOURCE) && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	    if (defined &__STDC__) {
	    }
	    else {
	    }
	}
    }
    if (defined &__cplusplus) {
    }
}
1;
