if (!defined &_SYS_VFS_H) {
    eval 'sub _SYS_VFS_H {1;}';
    require 'sys/types.ph';
    require 'sys/t_lock.ph';
    require 'sys/cred.ph';
    require 'sys/vnode.ph';
    require 'sys/statvfs.ph';
    if (defined &__cplusplus) {
    }
    eval 'sub MAXFIDSZ {64;}';
    eval 'sub OLD_MAXFIDSZ {16;}';
    eval 'sub fid_len { &un. &_fid. &len;}';
    eval 'sub fid_data { &un. &_fid. &data;}';
    eval 'sub VFS_RDONLY {0x01;}';
    eval 'sub VFS_NOSUID {0x08;}';
    eval 'sub VFS_REMOUNT {0x10;}';
    eval 'sub VFS_NOTRUNC {0x20;}';
    eval 'sub VFS_UNLINKABLE {0x40;}';
    eval 'sub VFS_MOUNT {
        local($vfsp, $mvp, $uap, $cr) = @_;
        eval "(*($vfsp)-> &vfs_op-> &vfs_mount)($vfsp, $mvp, $uap, $cr)";
    }';
    eval 'sub VFS_UNMOUNT {
        local($vfsp, $cr) = @_;
        eval "(*($vfsp)-> &vfs_op-> &vfs_unmount)($vfsp, $cr)";
    }';
    eval 'sub VFS_ROOT {
        local($vfsp, $vpp) = @_;
        eval "(*($vfsp)-> &vfs_op-> &vfs_root)($vfsp, $vpp)";
    }';
    eval 'sub VFS_STATVFS {
        local($vfsp, $sp) = @_;
        eval "(*($vfsp)-> &vfs_op-> &vfs_statvfs)($vfsp, $sp)";
    }';
    eval 'sub VFS_SYNC {
        local($vfsp, $flag, $cr) = @_;
        eval "(*($vfsp)-> &vfs_op-> &vfs_sync)($vfsp, $flag, $cr)";
    }';
    eval 'sub VFS_VGET {
        local($vfsp, $vpp, $fidp) = @_;
        eval "(*($vfsp)-> &vfs_op-> &vfs_vget)($vfsp, $vpp, $fidp)";
    }';
    eval 'sub VFS_MOUNTROOT {
        local($vfsp, $init) = @_;
        eval "(*($vfsp)-> &vfs_op-> &vfs_mountroot)($vfsp, $init)";
    }';
    eval 'sub VFS_SWAPVP {
        local($vfsp, $vpp, $nm) = @_;
        eval "(*($vfsp)-> &vfs_op-> &vfs_swapvp)($vfsp, $vpp, $nm)";
    }';
    if (defined( &_KERNEL)) {
	eval 'sub VFSHASH {
	    local($dev, $fstyp) = @_;
	    eval "(($dev + $fstyp) & ( &vfshsz - 1))";
	}';
    }
    eval 'sub VFS_INIT {
        local($vfsp, $op, $data) = @_;
        eval "{ ($vfsp)-> &vfs_next = 0; ($vfsp)-> &vfs_op = ($op); ($vfsp)-> &vfs_flag = 0; ($vfsp)-> &vfs_data = ($data); ($vfsp)-> &vfs_nsubmounts = 0;  &mutex_init(&($vfsp)-> &vfs_reflock, \\"mnt/sync lock\\",  &MUTEX_DEFAULT,  &NULL); }";
    }';
    eval 'sub VFS_INSTALLED {
        local($vfsswp) = @_;
        eval "(($vfsswp)-> &vsw_vfsops)";
    }';
    eval 'sub ALLOCATED_VFSSW {
        local($vswp) = @_;
        eval "(($vswp)-> &vsw_name[0] != ord(\'\\\\0\'))";
    }';
    eval 'sub RLOCK_VFSSW {
        eval "( &rw_enter(& &vfssw_lock,  &RW_READER))";
    }';
    eval 'sub RUNLOCK_VFSSW {
        eval "( &rw_exit(& &vfssw_lock))";
    }';
    eval 'sub WLOCK_VFSSW {
        eval "( &rw_enter(& &vfssw_lock,  &RW_WRITER))";
    }';
    eval 'sub WUNLOCK_VFSSW {
        eval "( &rw_exit(& &vfssw_lock))";
    }';
    eval 'sub VFSSW_LOCKED {
        eval "( &RW_LOCK_HELD(& &vfssw_lock))";
    }';
    eval 'sub VFSSW_WRITE_LOCKED {
        eval "( &RW_WRITE_HELD(& &vfssw_lock))";
    }';
    eval 'sub SYNC_ATTR {0x01;}';
    eval 'sub SYNC_CLOSE {0x02;}';
    eval 'sub SYNC_ALL {0x04;}';
    if (defined &__cplusplus) {
    }
}
1;
