if (!defined &_SYS_FS_HSFS_ISOSPEC_H) {
    eval 'sub _SYS_FS_HSFS_ISOSPEC_H {1;}';
    if (defined &__cplusplus) {
    }
    eval 'sub ZERO {
        local($x) = @_;
        eval " ((($x))[0])";
    }';
    eval 'sub ONE {
        local($x) = @_;
        eval " ((($x))[1])";
    }';
    eval 'sub TWO {
        local($x) = @_;
        eval " ((($x))[2])";
    }';
    eval 'sub THREE {
        local($x) = @_;
        eval " ((($x))[3])";
    }';
    eval 'sub MSB_INT {
        local($x) = @_;
        eval "(((((( &ZERO($x) << 8) |  &ONE($x)) << 8) |  &TWO($x)) << 8) |  &THREE($x))";
    }';
    eval 'sub LSB_INT {
        local($x) = @_;
        eval "(((((( &THREE($x) << 8) |  &TWO($x)) << 8) |  &ONE($x)) << 8) |  &ZERO($x))";
    }';
    eval 'sub MSB_SHORT {
        local($x) = @_;
        eval "(( &ZERO($x) << 8) |  &ONE($x))";
    }';
    eval 'sub LSB_SHORT {
        local($x) = @_;
        eval "(( &ONE($x) << 8) |  &ZERO($x))";
    }';
    if (defined( &i386) || defined( &__i386)) {
	eval 'sub BOTH_SHORT {
	    local($x) = @_;
	    eval " *($x)";
	}';
	eval 'sub BOTH_INT {
	    local($x) = @_;
	    eval " *($x)";
	}';
    }
    elsif (defined( &sparc) || defined( &__sparc) || defined( &__ppc)) {
	eval 'sub BOTH_SHORT {
	    local($x) = @_;
	    eval " &LSB_SHORT($x)";
	}';
	eval 'sub BOTH_INT {
	    local($x) = @_;
	    eval " &LSB_INT($x)";
	}';
    }
    eval 'sub ISO_SECTOR_SIZE {2048;}';
    eval 'sub ISO_SECTOR_SHIFT {11;}';
    eval 'sub ISO_SEC_PER_PAGE {( &PAGESIZE/ &HS_SECTOR_SIZE);}';
    eval 'sub ISO_SYSAREA_SEC {0;}';
    eval 'sub ISO_VOLDESC_SEC {16;}';
    eval 'sub MAXISOOFFSET {( &ISO_SECTOR_SIZE - 1);}';
    eval 'sub MAXISOMASK {(~ &MAXISOOFFSET);}';
    eval 'sub ISO_ID_STRING {"CD001";}';
    eval 'sub ISO_ID_STRLEN {5;}';
    eval 'sub ISO_ID_VER {1;}';
    eval 'sub ISO_FILE_STRUCT_ID_VER {1;}';
    eval 'sub ISO_SYS_ID_STRLEN {32;}';
    eval 'sub ISO_VOL_ID_STRLEN {32;}';
    eval 'sub ISO_VOL_SET_ID_STRLEN {128;}';
    eval 'sub ISO_PUB_ID_STRLEN {128;}';
    eval 'sub ISO_PREP_ID_STRLEN {128;}';
    eval 'sub ISO_APPL_ID_STRLEN {128;}';
    eval 'sub ISO_COPYR_ID_STRLEN {37;}';
    eval 'sub ISO_ABSTR_ID_STRLEN {37;}';
    eval 'sub ISO_SHORT_DATE_LEN {7;}';
    eval 'sub ISO_DATE_LEN {17;}';
    eval 'sub ISO_desc_type {
        local($x) = @_;
        eval "(&($x)[0])";
    }';
    eval 'sub ISO_std_id {
        local($x) = @_;
        eval "(&($x)[1])";
    }';
    eval 'sub ISO_std_ver {
        local($x) = @_;
        eval "(&($x)[6])";
    }';
    eval 'sub ISO_sys_id {
        local($x) = @_;
        eval "(&($x)[8])";
    }';
    eval 'sub ISO_vol_id {
        local($x) = @_;
        eval "(&($x)[40])";
    }';
    eval 'sub ISO_vol_size {
        local($x) = @_;
        eval "(&($x)[80])";
    }';
    eval 'sub ISO_set_size {
        local($x) = @_;
        eval "(&($x)[120])";
    }';
    eval 'sub ISO_set_seq {
        local($x) = @_;
        eval "(&($x)[124])";
    }';
    eval 'sub ISO_blk_size {
        local($x) = @_;
        eval "(&($x)[128])";
    }';
    eval 'sub ISO_ptbl_size {
        local($x) = @_;
        eval "(&($x)[132])";
    }';
    eval 'sub ISO_ptbl_man_ls {
        local($x) = @_;
        eval "(&($x)[140])";
    }';
    eval 'sub ISO_ptbl_opt_ls1 {
        local($x) = @_;
        eval "(&($x)[144])";
    }';
    eval 'sub ISO_ptbl_man_ms {
        local($x) = @_;
        eval "(&($x)[148])";
    }';
    eval 'sub ISO_ptbl_opt_ms1 {
        local($x) = @_;
        eval "(&($x)[152])";
    }';
    eval 'sub ISO_root_dir {
        local($x) = @_;
        eval "(&($x)[156])";
    }';
    eval 'sub ISO_vol_set_id {
        local($x) = @_;
        eval "(&($x)[190])";
    }';
    eval 'sub ISO_pub_id {
        local($x) = @_;
        eval "(&($x)[318])";
    }';
    eval 'sub ISO_prep_id {
        local($x) = @_;
        eval "(&($x)[446])";
    }';
    eval 'sub ISO_appl_id {
        local($x) = @_;
        eval "(&($x)[574])";
    }';
    eval 'sub ISO_copyr_id {
        local($x) = @_;
        eval "(&($x)[702])";
    }';
    eval 'sub ISO_abstr_id {
        local($x) = @_;
        eval "(&($x)[739])";
    }';
    eval 'sub ISO_bibli_id {
        local($x) = @_;
        eval "(&($x)[776])";
    }';
    eval 'sub ISO_cre_date {
        local($x) = @_;
        eval "(&($x)[813])";
    }';
    eval 'sub ISO_mod_date {
        local($x) = @_;
        eval "(&($x)[830])";
    }';
    eval 'sub ISO_exp_date {
        local($x) = @_;
        eval "(&($x)[847])";
    }';
    eval 'sub ISO_eff_date {
        local($x) = @_;
        eval "(&($x)[864])";
    }';
    eval 'sub ISO_file_struct_ver {
        local($x) = @_;
        eval "(&($x)[881])";
    }';
    eval 'sub ISO_DESC_TYPE {
        local($x) = @_;
        eval "(( &enum  &hs_voldesc_type)*( &ISO_desc_type($x)))";
    }';
    eval 'sub ISO_STD_ID {
        local($x) = @_;
        eval " &ISO_std_id($x)";
    }';
    eval 'sub ISO_STD_VER {
        local($x) = @_;
        eval "*( &ISO_std_ver($x))";
    }';
    eval 'sub ISO_SYS_ID {
        local($x) = @_;
        eval " &ISO_sys_id($x)";
    }';
    eval 'sub ISO_VOL_ID {
        local($x) = @_;
        eval " &ISO_vol_id($x)";
    }';
    eval 'sub ISO_VOL_SIZE {
        local($x) = @_;
        eval " &BOTH_INT( &ISO_vol_size($x))";
    }';
    eval 'sub ISO_SET_SIZE {
        local($x) = @_;
        eval " &BOTH_SHORT( &ISO_set_size($x))";
    }';
    eval 'sub ISO_SET_SEQ {
        local($x) = @_;
        eval " &BOTH_SHORT( &ISO_set_seq($x))";
    }';
    eval 'sub ISO_BLK_SIZE {
        local($x) = @_;
        eval " &BOTH_SHORT( &ISO_blk_size($x))";
    }';
    eval 'sub ISO_PTBL_SIZE {
        local($x) = @_;
        eval " &BOTH_INT( &ISO_ptbl_size($x))";
    }';
    eval 'sub ISO_PTBL_MAN_LS {
        local($x) = @_;
        eval " &LSB_INT( &ISO_ptbl_man_ls($x))";
    }';
    eval 'sub ISO_PTBL_OPT_LS1 {
        local($x) = @_;
        eval " &LSB_INT( &ISO_ptbl_opt_ls1($x))";
    }';
    eval 'sub ISO_PTBL_MAN_MS {
        local($x) = @_;
        eval " &MSB_INT( &ISO_ptbl_man_ms($x))";
    }';
    eval 'sub ISO_PTBL_OPT_MS1 {
        local($x) = @_;
        eval " &MSB_INT( &ISO_ptbl_opt_ms1($x))";
    }';
    eval 'sub ISO_ROOT_DIR {
        local($x) = @_;
        eval " &ISO_root_dir($x)";
    }';
    eval 'sub ISO_VOL_SET_ID {
        local($x) = @_;
        eval " &ISO_vol_set_id($x)";
    }';
    eval 'sub ISO_PUB_ID {
        local($x) = @_;
        eval " &ISO_pub_id($x)";
    }';
    eval 'sub ISO_PREP_ID {
        local($x) = @_;
        eval " &ISO_prep_id($x)";
    }';
    eval 'sub ISO_APPL_ID {
        local($x) = @_;
        eval " &ISO_appl_id($x)";
    }';
    eval 'sub ISO_COPYR_ID {
        local($x) = @_;
        eval " &ISO_copyr_id($x)";
    }';
    eval 'sub ISO_ABSTR_ID {
        local($x) = @_;
        eval " &ISO_abstr_id($x)";
    }';
    eval 'sub ISO_BIBLI_ID {
        local($x) = @_;
        eval " &ISO_bibli_id($x)";
    }';
    eval 'sub ISO_CRE_DATE {
        local($x) = @_;
        eval " &HSV_cre_date($x)";
    }';
    eval 'sub ISO_MOD_DATE {
        local($x) = @_;
        eval " &HSV_mod_date($x)";
    }';
    eval 'sub ISO_EXP_DATE {
        local($x) = @_;
        eval " &HSV_exp_date($x)";
    }';
    eval 'sub ISO_EFF_DATE {
        local($x) = @_;
        eval " &HSV_eff_date($x)";
    }';
    eval 'sub ISO_FILE_STRUCT_VER {
        local($x) = @_;
        eval "*( &ISO_file_struct_ver($x))";
    }';
    eval 'sub ISO_DATE_2DIG {
        local($x) = @_;
        eval "(((($x)[0] - ord(\'0\') * 10) +							((x)[1] - \'0\')))";
    }';
    eval 'sub ISO_DATE_4DIG {
        local($x) = @_;
        eval "(((($x)[0] - ord(\'0\') * 1000) +							(((x)[1] - \'0\') * 100) +						(((x)[2] - \'0\') * 10) +							((x)[3] - \'0\')))";
    }';
    eval 'sub ISO_DATE_YEAR {
        local($x) = @_;
        eval " &ISO_DATE_4DIG(&($x)[0])";
    }';
    eval 'sub ISO_DATE_MONTH {
        local($x) = @_;
        eval " &ISO_DATE_2DIG(&($x)[4])";
    }';
    eval 'sub ISO_DATE_DAY {
        local($x) = @_;
        eval " &ISO_DATE_2DIG(&($x)[6])";
    }';
    eval 'sub ISO_DATE_HOUR {
        local($x) = @_;
        eval " &ISO_DATE_2DIG(&($x)[8])";
    }';
    eval 'sub ISO_DATE_MIN {
        local($x) = @_;
        eval " &ISO_DATE_2DIG(&($x)[10])";
    }';
    eval 'sub ISO_DATE_SEC {
        local($x) = @_;
        eval " &ISO_DATE_2DIG(&($x)[12])";
    }';
    eval 'sub ISO_DATE_HSEC {
        local($x) = @_;
        eval " &ISO_DATE_2DIG(&($x)[14])";
    }';
    eval 'sub ISO_DATE_GMTOFF {
        local($x) = @_;
        eval "(($x)[16])";
    }';
    eval 'sub IDE_ROOT_DIR_REC_SIZE {34;}';
    eval 'sub IDE_FDESIZE {33;}';
    eval 'sub IDE_MAX_NAME_LEN {(255 -  &IDE_FDESIZE);}';
    eval 'sub IDE_dir_len {
        local($x) = @_;
        eval "(&($x)[0])";
    }';
    eval 'sub IDE_xar_len {
        local($x) = @_;
        eval "(&($x)[1])";
    }';
    eval 'sub IDE_ext_lbn {
        local($x) = @_;
        eval "(&($x)[2])";
    }';
    eval 'sub IDE_ext_size {
        local($x) = @_;
        eval "(&($x)[10])";
    }';
    eval 'sub IDE_cdate {
        local($x) = @_;
        eval "(&($x)[18])";
    }';
    eval 'sub IDE_flags {
        local($x) = @_;
        eval "(&($x)[25])";
    }';
    eval 'sub IDE_intrlv_size {
        local($x) = @_;
        eval "(&($x)[26])";
    }';
    eval 'sub IDE_intrlv_skip {
        local($x) = @_;
        eval "(&($x)[27])";
    }';
    eval 'sub IDE_vol_set {
        local($x) = @_;
        eval "(&($x)[28])";
    }';
    eval 'sub IDE_name_len {
        local($x) = @_;
        eval "(&($x)[32])";
    }';
    eval 'sub IDE_name {
        local($x) = @_;
        eval "(&($x)[33])";
    }';
    eval 'sub IDE_sys_use_area {
        local($x) = @_;
        eval "(&($x)[ &IDE_NAME_LEN($x) +  &IDE_PAD_LEN($x)] +  &IDE_FDESIZE)";
    }';
    eval 'sub IDE_DIR_LEN {
        local($x) = @_;
        eval "*( &IDE_dir_len($x))";
    }';
    eval 'sub IDE_XAR_LEN {
        local($x) = @_;
        eval "*( &IDE_xar_len($x))";
    }';
    eval 'sub IDE_EXT_LBN {
        local($x) = @_;
        eval " &BOTH_INT( &IDE_ext_lbn($x))";
    }';
    eval 'sub IDE_EXT_SIZE {
        local($x) = @_;
        eval " &BOTH_INT( &IDE_ext_size($x))";
    }';
    eval 'sub IDE_CDATE {
        local($x) = @_;
        eval " &IDE_cdate($x)";
    }';
    eval 'sub IDE_FLAGS {
        local($x) = @_;
        eval "*( &IDE_flags($x))";
    }';
    eval 'sub IDE_INTRLV_SIZE {
        local($x) = @_;
        eval "*( &IDE_intrlv_size($x))";
    }';
    eval 'sub IDE_INTRLV_SKIP {
        local($x) = @_;
        eval "*( &IDE_intrlv_skip($x))";
    }';
    eval 'sub IDE_VOL_SET {
        local($x) = @_;
        eval " &BOTH_SHORT( &IDE_vol_set($x))";
    }';
    eval 'sub IDE_NAME_LEN {
        local($x) = @_;
        eval "*( &IDE_name_len($x))";
    }';
    eval 'sub IDE_NAME {
        local($x) = @_;
        eval " &IDE_name($x)";
    }';
    eval 'sub IDE_PAD_LEN {
        local($x) = @_;
        eval "(( &IDE_NAME_LEN($x) % 2) ? 0 : 1)";
    }';
    eval 'sub IDE_SUA_LEN {
        local($x) = @_;
        eval "( &IDE_DIR_LEN($x) -  &IDE_FDESIZE -  &IDE_NAME_LEN($x) -  &IDE_PAD_LEN($x))";
    }';
    eval 'sub IDE_EXISTENCE {0x01;}';
    eval 'sub IDE_DIRECTORY {0x02;}';
    eval 'sub IDE_ASSOCIATED {0x04;}';
    eval 'sub IDE_RECORD {0x08;}';
    eval 'sub IDE_PROTECTION {0x10;}';
    eval 'sub IDE_UNUSED_FLAGS {0x60;}';
    eval 'sub IDE_LAST_EXTENT {0x80;}';
    eval 'sub IDE_PROHIBITED {( &IDE_DIRECTORY |  &HDE_ASSOCIATED |  &HDE_RECORD |  &IDE_LAST_EXTENT |  &IDE_UNUSED_FLAGS);}';
    eval 'sub IDE_DATE_YEAR {
        local($x) = @_;
        eval "(($x)[0] + 1900)";
    }';
    eval 'sub IDE_DATE_MONTH {
        local($x) = @_;
        eval "(($x)[1])";
    }';
    eval 'sub IDE_DATE_DAY {
        local($x) = @_;
        eval "(($x)[2])";
    }';
    eval 'sub IDE_DATE_HOUR {
        local($x) = @_;
        eval "(($x)[3])";
    }';
    eval 'sub IDE_DATE_MIN {
        local($x) = @_;
        eval "(($x)[4])";
    }';
    eval 'sub IDE_DATE_SEC {
        local($x) = @_;
        eval "(($x)[5])";
    }';
    eval 'sub IDE_DATE_GMTOFF {
        local($x) = @_;
        eval "(($x)[6])";
    }';
    eval 'sub IDE_REGULAR_FILE {
        local($x) = @_;
        eval "((($x) &  &IDE_PROHIBITED) == 0)";
    }';
    eval 'sub IDE_REGULAR_DIR {
        local($x) = @_;
        eval "((($x) &  &IDE_PROHIBITED) ==  &IDE_DIRECTORY)";
    }';
    eval 'sub ISO_DIR_NAMELEN {31;}';
    eval 'sub ISO_FILE_NAMELEN {31;}';
    eval 'sub IPE_FPESIZE {8;}';
    eval 'sub IPE_name_len {
        local($x) = @_;
        eval "(&($x)[0])";
    }';
    eval 'sub IPE_xar_len {
        local($x) = @_;
        eval "(&($x)[1])";
    }';
    eval 'sub IPE_ext_lbn {
        local($x) = @_;
        eval "(&($x)[2])";
    }';
    eval 'sub IPE_parent_no {
        local($x) = @_;
        eval "(&($x)[6])";
    }';
    eval 'sub IPE_name {
        local($x) = @_;
        eval "(&($x)[8])";
    }';
    eval 'sub IPE_EXT_LBN {
        local($x) = @_;
        eval "( &MSB_INT( &IPE_ext_lbn($x)))";
    }';
    eval 'sub IPE_XAR_LEN {
        local($x) = @_;
        eval "*( &IPE_xar_len($x))";
    }';
    eval 'sub IPE_NAME_LEN {
        local($x) = @_;
        eval "*( &IPE_name_len($x))";
    }';
    eval 'sub IPE_PARENT_NO {
        local($x) = @_;
        eval "*( &IPE_parent_no($x))";
    }';
    eval 'sub IPE_NAME {
        local($x) = @_;
        eval " &IPE_name($x)";
    }';
    if (defined &__cplusplus) {
    }
}
1;
