if (!defined &_SYS_FS_TMPNODE_H) {
    eval 'sub _SYS_FS_TMPNODE_H {1;}';
    require 'sys/t_lock.ph';
    require 'vm/seg.ph';
    require 'vm/seg_vn.ph';
    if (defined &__cplusplus) {
    }
    eval 'sub tn_dir { &un_tmpnode. &un_dir;}';
    eval 'sub tn_symlink { &un_tmpnode. &un_symlink;}';
    eval 'sub tn_anon { &un_tmpnode. &un_anonstruct. &un_anon;}';
    eval 'sub tn_asize { &un_tmpnode. &un_anonstruct. &un_size;}';
    eval 'sub tn_mask { &tn_attr. &va_mask;}';
    eval 'sub tn_type { &tn_attr. &va_type;}';
    eval 'sub tn_mode { &tn_attr. &va_mode;}';
    eval 'sub tn_uid { &tn_attr. &va_uid;}';
    eval 'sub tn_gid { &tn_attr. &va_gid;}';
    eval 'sub tn_fsid { &tn_attr. &va_fsid;}';
    eval 'sub tn_nodeid { &tn_attr. &va_nodeid;}';
    eval 'sub tn_nlink { &tn_attr. &va_nlink;}';
    eval 'sub tn_size { &tn_attr. &va_size;}';
    eval 'sub tn_atime { &tn_attr. &va_atime;}';
    eval 'sub tn_mtime { &tn_attr. &va_mtime;}';
    eval 'sub tn_ctime { &tn_attr. &va_ctime;}';
    eval 'sub tn_rdev { &tn_attr. &va_rdev;}';
    eval 'sub tn_blksize { &tn_attr. &va_blksize;}';
    eval 'sub tn_nblocks { &tn_attr. &va_nblocks;}';
    eval 'sub tn_vcode { &tn_attr. &va_vcode;}';
    eval 'sub TREF {0x001;}';
    eval 'sub TUPD {0x002;}';
    eval 'sub TACC {0x004;}';
    eval 'sub TCHG {0x008;}';
    eval 'sub TMAP {0x010;}';
    eval 'sub TFREE {0x020;}';
    eval 'sub tmp_accessed {
        local($t) = @_;
        eval " &tmp_timestamp(($t), ((($t)-> &tn_flags)| &TACC))";
    }';
    eval 'sub tmp_modified {
        local($t) = @_;
        eval " &tmp_timestamp(($t), ((($t)-> &tn_flags)| &TACC| &TUPD))";
    }';
    eval 'sub tmp_created {
        local($t) = @_;
        eval " &tmp_timestamp(($t), ((($t)-> &tn_flags)| &TACC| &TUPD| &TCHG))";
    }';
    eval 'sub ESAME {(-1);}';
    if (defined &__cplusplus) {
    }
}
1;
