if (!defined &_SYS_FS_UFS_TRANS_H) {
    eval 'sub _SYS_FS_UFS_TRANS_H {1;}';
    if (defined &__cplusplus) {
    }
    require 'sys/types.ph';
    require 'sys/cred.ph';
    require 'sys/fs/ufs_fs.ph';
    eval 'sub UT_UNMOUNTED {(0);}';
    eval 'sub UT_MOUNTED {(1);}';
    eval 'sub UT_HLOCKING {(2);}';
    if (!defined &NOHARPY) {
	eval 'sub TRANS_ISTRANS {
	    local($ufsvfsp) = @_;
	    eval "($ufsvfsp-> &vfs_trans)";
	}';
	eval 'sub TRANS_BEGIN_SYNC {
	    local($ufsvfsp, $vid, $vsize) = @_;
	    eval "{  &if ( &TRANS_ISTRANS($ufsvfsp)) (*$ufsvfsp-> &vfs_trans-> &ut_ops-> &trans_begin_sync) ($ufsvfsp-> &vfs_trans, $vid, $vsize); }";
	}';
	eval 'sub TRANS_BEGIN_ASYNC {
	    local($ufsvfsp, $vid, $vsize) = @_;
	    eval "{  &if ( &TRANS_ISTRANS($ufsvfsp)) (*$ufsvfsp-> &vfs_trans-> &ut_ops-> &trans_begin_async) ($ufsvfsp-> &vfs_trans, $vid, $vsize); }";
	}';
	eval 'sub TRANS_BEGIN_CSYNC {
	    local($ufsvfsp, $issync, $vid, $vsize) = @_;
	    eval "{  &if ( &TRANS_ISTRANS($ufsvfsp)) {  &if ($ufsvfsp-> &vfs_syncdir ||  &curthread-> &t_flag &  &T_DONTPEND) { (*$ufsvfsp-> &vfs_trans-> &ut_ops-> &trans_begin_sync) ($ufsvfsp-> &vfs_trans, $vid, $vsize); $issync = 1; }  &else { (*$ufsvfsp-> &vfs_trans-> &ut_ops-> &trans_begin_async) ($ufsvfsp-> &vfs_trans, $vid, $vsize); $issync = 0; } }}";
	}';
	eval 'sub TRANS_END_ASYNC {
	    local($ufsvfsp, $vid, $vsize) = @_;
	    eval "{  &if ( &TRANS_ISTRANS($ufsvfsp)) (*$ufsvfsp-> &vfs_trans-> &ut_ops-> &trans_end_async) ($ufsvfsp-> &vfs_trans, $vid, $vsize); }";
	}';
	eval 'sub TRANS_END_SYNC {
	    local($ufsvfsp, $error, $vid, $vsize) = @_;
	    eval "{  &if ( &TRANS_ISTRANS($ufsvfsp)) (*$ufsvfsp-> &vfs_trans-> &ut_ops-> &trans_end_sync) ($ufsvfsp-> &vfs_trans, &$error, $vid, $vsize); }";
	}';
	eval 'sub TRANS_END_CSYNC {
	    local($ufsvfsp, $error, $issync, $vid, $vsize) = @_;
	    eval "{  &if ( &TRANS_ISTRANS($ufsvfsp))  &if ($issync) (*$ufsvfsp-> &vfs_trans-> &ut_ops-> &trans_end_sync) ($ufsvfsp-> &vfs_trans, &$error, $vid, $vsize);  &else (*$ufsvfsp-> &vfs_trans-> &ut_ops-> &trans_end_async) ($ufsvfsp-> &vfs_trans, $vid, $vsize); }";
	}';
	eval 'sub TRANS_DELTA {
	    local($ufsvfsp, $mof, $nb, $dtyp, $func, $arg) = @_;
	    eval " &if ( &TRANS_ISTRANS($ufsvfsp)) (*$ufsvfsp-> &vfs_trans-> &ut_ops-> &trans_delta) ($ufsvfsp-> &vfs_trans, ( &offset_t) ($mof), $nb, $dtyp, $func, $arg)";
	}';
	eval 'sub TRANS_UD_DELTA {
	    local($ufsvfsp, $mof, $nb, $dtyp, $func, $arg) = @_;
	    eval "(( &TRANS_ISTRANS($ufsvfsp)) ? (*$ufsvfsp-> &vfs_trans-> &ut_ops-> &trans_ud_delta) ($ufsvfsp-> &vfs_trans, ( &offset_t) ($mof), $nb, $dtyp, $func, $arg) : 0)";
	}';
	eval 'sub TRANS_CANCEL {
	    local($ufsvfsp, $mof, $nb) = @_;
	    eval " &if ( &TRANS_ISTRANS($ufsvfsp)) (*$ufsvfsp-> &vfs_trans-> &ut_ops-> &trans_cancel) ($ufsvfsp-> &vfs_trans, ( &offset_t) ($mof), $nb)";
	}';
	eval 'sub TRANS_LOG {
	    local($ufsvfsp, $va, $mof, $nb) = @_;
	    eval " &if ( &TRANS_ISTRANS($ufsvfsp)) (*$ufsvfsp-> &vfs_trans-> &ut_ops-> &trans_log) ($ufsvfsp-> &vfs_trans, $va, ( &offset_t) ($mof), $nb)";
	}';
	eval 'sub TRANS_ISCANCEL {
	    local($ufsvfsp, $mof, $nb) = @_;
	    eval "(( &TRANS_ISTRANS($ufsvfsp)) ? (*$ufsvfsp-> &vfs_trans-> &ut_ops-> &trans_iscancel) ($ufsvfsp-> &vfs_trans, ( &offset_t) ($mof), $nb) : 0)";
	}';
	eval 'sub TRANS_SETERROR {
	    local($ufsvfsp) = @_;
	    eval " &if ( &TRANS_ISTRANS($ufsvfsp)) (*$ufsvfsp-> &vfs_trans-> &ut_ops-> &trans_seterror) ($ufsvfsp-> &vfs_trans)";
	}';
	eval 'sub TRANS_ISERROR {
	    local($ufsvfsp) = @_;
	    eval "(( &TRANS_ISTRANS($ufsvfsp)) ? (*$ufsvfsp-> &vfs_trans-> &ut_ops-> &trans_iserror) ($ufsvfsp-> &vfs_trans) : 0)";
	}';
	eval 'sub TRANS_BUF {
	    local($ufsvfsp, $vof, $nb, $bp, $type) = @_;
	    eval " &TRANS_DELTA($ufsvfsp,  &ldbtob($bp-> &b_blkno) + ( &offset_t) ($vof), $nb, $type,  &ufs_trans_push_buf, $bp-> &b_blkno)";
	}';
	eval 'sub TRANS_BUF_ITEM {
	    local($ufsvfsp, $item, $base, $bp, $type) = @_;
	    eval " &TRANS_BUF($ufsvfsp, ( &caddr_t)&($item) - ( &caddr_t)($base), $sizeof{$item}, $bp, $type)";
	}';
	eval 'sub TRANS_BUF_ITEM_128 {
	    local($ufsvfsp, $item, $base, $bp, $type) = @_;
	    eval " &TRANS_BUF($ufsvfsp, ((&($item)) & ~(128 - 1)) - ($base), 128, $bp, $type)";
	}';
	eval 'sub TRANS_UD_BUF {
	    local($ufsvfsp, $islogged, $vof, $nb, $bp, $type) = @_;
	    eval "{ $islogged =  &TRANS_UD_DELTA($ufsvfsp,  &ldbtob($bp-> &b_blkno) + ( &offset_t) ($vof), $nb, $type,  &ufs_trans_push_buf, $bp-> &b_blkno); }";
	}';
	eval 'sub TRANS_INODE {
	    local($ufsvfsp, $ip) = @_;
	    eval " &TRANS_DELTA($ufsvfsp, $ip-> &i_doff, $sizeof{\'struct dinode\'},  &DT_INODE,  &ufs_trans_push_inode, $ip-> &i_number)";
	}';
	eval 'sub TRANS_INODE_DELTA {
	    local($ufsvfsp, $vof, $nb, $ip) = @_;
	    eval " &TRANS_DELTA($ufsvfsp, ($ip-> &i_doff + ( &offset_t) ($vof)), $nb,  &DT_INODE,  &ufs_trans_push_inode, $ip-> &i_number)";
	}';
	eval 'sub TRANS_INODE_FIELD {
	    local($ufsvfsp, $field, $ip) = @_;
	    eval " &TRANS_INODE_DELTA($ufsvfsp, ( &caddr_t)&($field) - ( &caddr_t)&$ip-> &i_ic, $sizeof{$field}, $ip)";
	}';
	eval 'sub TRANS_CG {
	    local($ufsvfsp, $bp) = @_;
	    eval " &TRANS_BUF($ufsvfsp, 0,  &sizeofcg, $bp,  &DT_CG)";
	}';
	eval 'sub TRANS_SI {
	    local($ufsvfsp, $fs, $cg) = @_;
	    eval " &TRANS_DELTA($ufsvfsp,  &ldbtob( &fsbtodb($fs, $fs-> &fs_csaddr)) + (( &caddr_t)&$fs-> &fs_cs($fs, $cg) - ( &caddr_t)$fs-> &fs_csp[0]), $sizeof{\'struct csum\'},  &DT_SI,  &ufs_trans_push_si, $cg)";
	}';
	eval 'sub TRANS_DIR {
	    local($ip, $offset, $err) = @_;
	    eval " &if ( &TRANS_ISTRANS($ip-> &i_ufsvfs)) $err =  &ufs_trans_dir($ip, $offset);  &else $err = 0;";
	}';
	eval 'sub TRANS_QUOTA {
	    local($dqp) = @_;
	    eval " &if ( &TRANS_ISTRANS($dqp-> &dq_ufsvfsp))  &ufs_trans_quota($dqp);";
	}';
	eval 'sub TRANS_DQRELE {
	    local($dqp) = @_;
	    eval " &if ($dqp)  &if ( &TRANS_ISTRANS($dqp-> &dq_ufsvfsp))  &ufs_trans_dqrele($dqp);  &else  &dqrele($dqp);";
	}';
	eval 'sub TRANS_ITRUNC {
	    local($ip, $length, $flags, $cr) = @_;
	    eval " &ufs_trans_itrunc($ip, $length, $flags, $cr);";
	}';
	eval 'sub TRANS_WRITE {
	    local($ip, $uiop, $ioflag, $err, $ulp, $cr) = @_;
	    eval " &if (( &TRANS_ISTRANS($ip-> &i_ufsvfs) !=  &NULL) && ($ulp !=  &NULL)) $err =  &ufs_trans_write($ip, $uiop, $ioflag, $cr);  &else $err =  &rwip($ip, $uiop,  &UIO_WRITE, $ioflag, $cr);";
	}';
	eval 'sub TRANS_SBUPDATE {
	    local($ufsvfsp, $vfsp, $topid) = @_;
	    eval " &ufs_trans_sbupdate($ufsvfsp, $vfsp, $topid)";
	}';
	eval 'sub TRANS_SYNCIP {
	    local($ip, $bflags, $iflag, $topid) = @_;
	    eval " &ufs_trans_syncip($ip, $bflags, $iflag, $topid)";
	}';
	eval 'sub TRANS_SBWRITE {
	    local($ufsvfsp, $topid) = @_;
	    eval " &ufs_trans_sbwrite($ufsvfsp, $topid)";
	}';
	eval 'sub TRANS_IUPDAT {
	    local($ip, $waitfor) = @_;
	    eval " &ufs_trans_iupdat($ip, $waitfor)";
	}';
	eval 'sub TRANS_DOMATAMAP {
	    local($ufsvfsp) = @_;
	    eval "$ufsvfsp-> &vfs_domatamap = ( &TRANS_ISTRANS($ufsvfsp) && $ufsvfsp-> &vfs_trans-> &ut_ops-> &trans_mataadd)";
	}';
	eval 'sub TRANS_MATA_IGET {
	    local($ufsvfsp, $ip) = @_;
	    eval " &if ($ufsvfsp-> &vfs_domatamap)  &ufs_trans_mata_iget($ip)";
	}';
	eval 'sub TRANS_MATA_FREE {
	    local($ufsvfsp, $mof, $nb) = @_;
	    eval " &if ($ufsvfsp-> &vfs_domatamap)  &ufs_trans_mata_free($ufsvfsp, ( &offset_t) ($mof), $nb)";
	}';
	eval 'sub TRANS_MATA_ALLOC {
	    local($ufsvfsp, $ip, $bno, $size, $zero) = @_;
	    eval " &if ($ufsvfsp-> &vfs_domatamap)  &ufs_trans_mata_alloc($ufsvfsp, $ip, $bno, $size, $zero)";
	}';
	eval 'sub TRANS_MATA_MOUNT {
	    local($ufsvfsp) = @_;
	    eval " &if ($ufsvfsp-> &vfs_domatamap)  &ufs_trans_mata_mount($ufsvfsp)";
	}';
	eval 'sub TRANS_MATA_UMOUNT {
	    local($ufsvfsp) = @_;
	    eval " &if ($ufsvfsp-> &vfs_domatamap)  &ufs_trans_mata_umount($ufsvfsp)";
	}';
	eval 'sub TRANS_MATA_SI {
	    local($ufsvfsp, $fs) = @_;
	    eval " &if ($ufsvfsp-> &vfs_domatamap)  &ufs_trans_mata_si($ufsvfsp, $fs)";
	}';
	eval 'sub TRANS_MATAADD {
	    local($ufsvfsp, $mof, $nb) = @_;
	    eval "(*$ufsvfsp-> &vfs_trans-> &ut_ops-> &trans_mataadd) ($ufsvfsp-> &vfs_trans, ( &offset_t) ($mof), $nb)";
	}';
	eval 'sub TRANS_MATADEL {
	    local($ufsvfsp, $mof, $nb) = @_;
	    eval "(*$ufsvfsp-> &vfs_trans-> &ut_ops-> &trans_matadel) ($ufsvfsp-> &vfs_trans, ( &offset_t) ($mof), $nb)";
	}';
	eval 'sub TRANS_MATACLR {
	    local($ufsvfsp) = @_;
	    eval "(*$ufsvfsp-> &vfs_trans-> &ut_ops-> &trans_mataclr)($ufsvfsp-> &vfs_trans)";
	}';
    }
    else {
	eval 'sub TRANS_ISTRANS {
	    local($ufsvfsp) = @_;
	    eval "(0)";
	}';
	eval 'sub TRANS_BEGIN_SYNC {
	    local($ufsvfsp, $vid, $vsize) = @_;
	    eval "";
	}';
	eval 'sub TRANS_BEGIN_ASYNC {
	    local($ufsvfsp, $vid, $vsize) = @_;
	    eval "";
	}';
	eval 'sub TRANS_BEGIN_CSYNC {
	    local($ufsvfsp, $issync, $vid, $vsize) = @_;
	    eval "";
	}';
	eval 'sub TRANS_END_SYNC {
	    local($ufsvfsp, $error, $vid, $vsize) = @_;
	    eval "";
	}';
	eval 'sub TRANS_END_ASYNC {
	    local($ufsvfsp, $vid, $vsize) = @_;
	    eval "";
	}';
	eval 'sub TRANS_END_CSYNC {
	    local($ufsvfsp, $error, $issync, $vid, $vsize) = @_;
	    eval "";
	}';
	eval 'sub TRANS_DELTA {
	    local($ufsvfsp, $mof, $nb, $dtyp, $arg1, $arg2) = @_;
	    eval "";
	}';
	eval 'sub TRANS_UD_DELTA {
	    local($ufsvfsp, $mof, $nb, $dtyp, $arg1, $arg2) = @_;
	    eval "(0)";
	}';
	eval 'sub TRANS_CANCEL {
	    local($ufsvfsp, $mof, $nb) = @_;
	    eval "";
	}';
	eval 'sub TRANS_LOG {
	    local($ufsvfsp, $va, $mof, $nb) = @_;
	    eval "";
	}';
	eval 'sub TRANS_ISCANCEL {
	    local($ufsvfsp, $mof, $nb) = @_;
	    eval "(0)";
	}';
	eval 'sub TRANS_SETERROR {
	    local($ufsvfsp) = @_;
	    eval "";
	}';
	eval 'sub TRANS_ISERROR {
	    local($ufsvfsp) = @_;
	    eval "(0)";
	}';
	eval 'sub TRANS_BUF {
	    local($ufsvfsp, $offset, $nb, $bp, $type) = @_;
	    eval "";
	}';
	eval 'sub TRANS_UBUF {
	    local($ufsvfsp, $islogged, $offset, $nb, $bp, $type) = @_;
	    eval "($islogged = 0)";
	}';
	eval 'sub TRANS_BUF_ITEM {
	    local($ufsvfsp, $item, $base, $bp, $type) = @_;
	    eval "";
	}';
	eval 'sub TRANS_INODE {
	    local($ufsvfsp, $ip) = @_;
	    eval "";
	}';
	eval 'sub TRANS_SI {
	    local($ufsvfsp, $fs, $cg) = @_;
	    eval "";
	}';
	eval 'sub TRANS_DIR {
	    local($ip, $offset, $err) = @_;
	    eval "";
	}';
	eval 'sub TRANS_QUOTA {
	    local($dqp) = @_;
	    eval "";
	}';
	eval 'sub TRANS_DQRELE {
	    local($dqp) = @_;
	    eval "";
	}';
	eval 'sub TRANS_SBUPDATE {
	    local($ufsvfsp, $vfsp, $topid) = @_;
	    eval " &sbupdate($vfsp)";
	}';
	eval 'sub TRANS_SYNCIP {
	    local($ip, $bflags, $iflag, $topid) = @_;
	    eval " &ufs_syncip($ip, $bflags, $iflag)";
	}';
	eval 'sub TRANS_ITRUNC {
	    local($ip, $vap, $length, $cr) = @_;
	    eval "{  &rw_enter(&$ip-> &i_contents,  &RW_WRITER);  &ufs_itrunc($ip, $vap, $length, $cr);  &rw_exit(&$ip-> &i_contents); }";
	}';
	eval 'sub TRANS_WRITE {
	    local($ip, $uiop, $ioflag, $err, $ulp, $cr) = @_;
	    eval "$err =  &rwip($ip, $uiop,  &UIO_WRITE, $ioflag, $cr);";
	}';
	eval 'sub TRANS_IUPDAT {
	    local($ip, $waitfor) = @_;
	    eval "{  &rw_enter(&$ip-> &i_contents,  &RW_WRITER);  &ufs_iupdat($ip, $waitfor);  &rw_exit(&$ip-> &i_contents); }";
	}';
	eval 'sub TRANS_SBWRITE {
	    local($ufsvfsp, $topid) = @_;
	    eval "{  &mutex_enter(&$ufsvfsp-> &vfs_lock);  &ufs_sbwrite($ufsvfsp);  &mutex_exit(&$ufsvfsp-> &vfs_lock); }";
	}';
	eval 'sub TRANS_DOMATAMAP {
	    local($ufsvfsp) = @_;
	    eval "(0)";
	}';
	eval 'sub TRANS_MATA_IGET {
	    local($ufsvfsp, $ip) = @_;
	    eval "";
	}';
	eval 'sub TRANS_MATA_FREE {
	    local($ufsvfsp, $mof, $nb) = @_;
	    eval "";
	}';
	eval 'sub TRANS_MATA_ALLOC {
	    local($ufsvfsp, $ip, $bno, $size, $zero) = @_;
	    eval "";
	}';
	eval 'sub TRANS_MATA_MOUNT {
	    local($ufsvfsp) = @_;
	    eval "";
	}';
	eval 'sub TRANS_MATA_UMOUNT {
	    local($ufsvfsp) = @_;
	    eval "";
	}';
	eval 'sub TRANS_MATAADD {
	    local($ufsvfsp, $mof, $nb) = @_;
	    eval "";
	}';
	eval 'sub TRANS_MATADEL {
	    local($ufsvfsp, $mof, $nb) = @_;
	    eval "";
	}';
	eval 'sub TRANS_MATACLR {
	    local($ufsvfsp) = @_;
	    eval "";
	}';
    }
    require 'sys/fs/ufs_quota.ph';
    require 'sys/fs/ufs_lockfs.ph';
    eval 'sub TOP_SYNC {(0x00000001);}';
    eval 'sub TOP_ASYNC {(0x00000002);}';
    eval 'sub HEADERSIZE {(24);}';
    eval 'sub ALLOCSIZE {(160);}';
    eval 'sub SIZECG {(192);}';
    eval 'sub INODESIZE {($sizeof{\'struct dinode\'} +  &HEADERSIZE);}';
    eval 'sub SIZESB {(($sizeof{\'struct fs\'}) +  &HEADERSIZE);}';
    eval 'sub SIZEDIR {( &DIRBLKSIZ +  &HEADERSIZE);}';
    eval 'sub FRAGSIZE {
        local($IP) = @_;
        eval "($IP)-> &i_fs-> &fs_fsize";
    }';
    eval 'sub ACLSIZE {
        local($IP) = @_;
        eval "((($IP)-> &i_ufsvfs-> &vfs_maxacl) +  &INODESIZE)";
    }';
    eval 'sub MAXACLSIZE {(( &MAX_ACL_ENTRIES << 1) * $sizeof{ &aclent_t});}';
    eval 'sub DIRSIZE {
        local($IP) = @_;
        eval "( &INODESIZE + (4 *  &ALLOCSIZE) + ($IP)-> &i_fs-> &fs_fsize)";
    }';
    eval 'sub QUOTASIZE {$sizeof{\'struct dquot\'} +  &HEADERSIZE;}';
    eval 'sub TOP_CREATE_SIZE {
        local($IP) = @_;
        eval "( &ACLSIZE($IP) +  &SIZECG +  &DIRSIZE($IP) +  &INODESIZE)";
    }';
    eval 'sub TOP_REMOVE_SIZE {
        local($IP) = @_;
        eval " &DIRSIZE($IP) +  &SIZECG +  &INODESIZE +  &SIZESB";
    }';
    eval 'sub TOP_LINK_SIZE {
        local($IP) = @_;
        eval " &DIRSIZE($IP) +  &INODESIZE";
    }';
    eval 'sub TOP_RENAME_SIZE {
        local($IP) = @_;
        eval " &DIRSIZE($IP) +  &DIRSIZE($IP) +  &SIZECG";
    }';
    eval 'sub TOP_MKDIR_SIZE {
        local($IP) = @_;
        eval " &DIRSIZE($IP) +  &INODESIZE +  &DIRSIZE($IP) +  &INODESIZE +  &FRAGSIZE($IP) +  &SIZECG +  &ACLSIZE($IP)";
    }';
    eval 'sub TOP_SYMLINK_SIZE {
        local($IP) = @_;
        eval " &DIRSIZE(($IP)) +  &INODESIZE + 2048 +  &INODESIZE +  &SIZECG";
    }';
    eval 'sub TOP_GETPAGE_SIZE {
        local($IP) = @_;
        eval " &ALLOCSIZE +  &ALLOCSIZE +  &ALLOCSIZE +  &INODESIZE +  &SIZECG";
    }';
    eval 'sub TOP_SYNCIP_SIZE { &INODESIZE;}';
    eval 'sub TOP_FSYNC_SIZE { &INODESIZE;}';
    eval 'sub TOP_READ_SIZE { &INODESIZE;}';
    eval 'sub TOP_RMDIR_SIZE {( &SIZESB + ( &INODESIZE * 2) +  &SIZEDIR);}';
    eval 'sub TOP_SETQUOTA_SIZE {
        local($FS) = @_;
        eval "(($FS)-> &fs_bsize << 2)";
    }';
    eval 'sub TOP_QUOTA_SIZE {( &QUOTASIZE);}';
    eval 'sub TOP_SETSECATTR_SIZE {
        local($IP) = @_;
        eval "( &MAXACLSIZE)";
    }';
    eval 'sub TOP_IUPDAT_SIZE { &INODESIZE +  &SIZECG;}';
    eval 'sub TOP_SBUPDATE_SIZE {( &SIZESB);}';
    eval 'sub TOP_SBWRITE_SIZE {( &SIZESB);}';
    eval 'sub TOP_PUTPAGE_SIZE {( &INODESIZE +  &SIZECG);}';
    eval 'sub TOP_SETATTR_SIZE {
        local($IP) = @_;
        eval "( &SIZECG +  &INODESIZE +  &QUOTASIZE +  &ACLSIZE($IP))";
    }';
    eval 'sub TOP_IFREE_SIZE {
        local($IP) = @_;
        eval "( &SIZECG +  &INODESIZE +  &QUOTASIZE)";
    }';
    eval 'sub TOP_MOUNT_SIZE {( &SIZESB);}';
    eval 'sub TOP_ITRUNC_UP_SIZE {( &INODESIZE + (4 *  &ALLOCSIZE));}';
    eval 'sub TOP_ITRUNC_BLOCKS {(1024);}';
    eval 'sub TOP_ITRUNC_SIZECG {(256);}';
    eval 'sub TOP_ITRUNC_DBTOBLKS {
        local($FS, $IP) = @_;
        eval "(( &fragstoblks($FS,  &dbtofsb($FS, ($IP)-> &i_blocks))) + 1)";
    }';
    eval 'sub TOP_WRITE_SMALL_SIZE {(16384);}';
    eval 'sub TOP_WRITE_BIG_SIZE {(131072);}';
    eval 'sub SMALL_WRITE_SIZE {
        local($fsp) = @_;
        eval "((( &TOP_WRITE_SMALL_SIZE - (4 *  &ALLOCSIZE))/ ( &SIZECG +  &ALLOCSIZE)) * ($fsp)-> &fs_bsize)";
    }';
    eval 'sub TOP_COMMIT_SIZE {(0);}';
    if (defined( &_KERNEL) && defined( &__STDC__)) {
    }
    if (defined &__cplusplus) {
    }
}
1;
