if (!defined &_PCMCIA_H) {
    eval 'sub _PCMCIA_H {1;}';
    if (defined &__cplusplus) {
    }
    if (defined( &DEBUG)) {
	eval 'sub PCMCIA_DEBUG {1;}';
    }
    require 'sys/modctl.ph';
    eval 'sub PCMCIA_MAX_ADAPTERS {8;}';
    eval 'sub PCMCIA_MAX_SOCKETS {64;}';
    eval 'sub PCMCIA_MAX_WIN_ADAPT {40;}';
    eval 'sub PCMCIA_MAX_WINDOWS {( &PCMCIA_MAX_ADAPTERS* &PCMCIA_MAX_WIN_ADAPT);}';
    eval 'sub PCMCIA_MAX_POWER {16;}';
    eval 'sub _VERSION {
        local($major, $minor) = @_;
        eval "(($major)<<16|($minor))";
    }';
    eval 'sub PCMCIA_NEXUS_NAME {"pcmcia";}';
    eval 'sub PCMCIA_ADAPTER_NODE {"ddi_pcmcia:adapter";}';
    eval 'sub PCMCIA_SOCKET_NODE {"ddi_pcmcia:socket";}';
    eval 'sub PCMCIA_PCCARD_NODE {"ddi_pcmcia:pccard";}';
    eval 'sub PCIF_MAGIC {0x50434946;}';
    eval 'sub PCIF_VERSION { &_VERSION(0, 1);}';
    eval 'sub PCIF_MIN_VERSION { &_VERSION(0, 1);}';
    eval 'sub DEFAULT_CS_NAME {"cs";}';
    eval 'sub GET_SOCKET_STATUS {
        local($f, $dip, $sock, $stat) = @_;
        eval "(*($f)-> &pcif_get_socket_status)($dip, $sock, $stat)";
    }';
    eval 'sub SET_CALLBACK {
        local($f, $dip, $callback, $sock) = @_;
        eval "(*($f)-> &pcif_set_callback)($dip, $callback, $sock)";
    }';
    eval 'sub GET_ADAPTER {
        local($f, $dip, $conf) = @_;
        eval "(*($f)-> &pcif_get_adapter) ($dip, $conf)";
    }';
    eval 'sub GET_SOCKET {
        local($f, $dip, $sock) = @_;
        eval "(*($f)-> &pcif_get_socket)($dip, $sock)";
    }';
    eval 'sub GET_STATUS {
        local($f, $dip, $status) = @_;
        eval "(*($f)-> &pcif_get_status)($dip, $status)";
    }';
    eval 'sub GET_WINDOW {
        local($f, $dip, $window) = @_;
        eval "(*($f)-> &pcif_get_window)($dip, $window)";
    }';
    eval 'sub INQUIRE_ADAPTER {
        local($f, $dip, $inquire) = @_;
        eval "(*($f)-> &pcif_inquire_adapter)($dip, $inquire)";
    }';
    eval 'sub GET_CONFIG {
        local($f, $dip, $conf) = @_;
        eval " &INQUIRE_ADAPTER($f, $dip, $conf)";
    }';
    eval 'sub INQUIRE_SOCKET {
        local($f, $dip, $sock) = @_;
        eval "(*($f)-> &pcif_inquire_socket)($dip, $sock)";
    }';
    eval 'sub GET_PAGE {
        local($f, $dip, $page) = @_;
        eval "(*($f)-> &pcif_get_page)($dip, $page)";
    }';
    eval 'sub INQUIRE_WINDOW {
        local($f, $dip, $window) = @_;
        eval "(*($f)-> &pcif_inquire_window)($dip, $window)";
    }';
    eval 'sub RESET_SOCKET {
        local($f, $dip, $socket, $mode) = @_;
        eval "(*($f)-> &pcif_reset_socket)($dip, $socket, $mode)";
    }';
    eval 'sub SET_PAGE {
        local($f, $dip, $page) = @_;
        eval "(*($f)-> &pcif_set_page)($dip, $page)";
    }';
    eval 'sub SET_WINDOW {
        local($f, $dip, $window) = @_;
        eval "(*($f)-> &pcif_set_window)($dip, $window)";
    }';
    eval 'sub SET_SOCKET {
        local($f, $dip, $socket) = @_;
        eval "(*($f)-> &pcif_set_socket)($dip, $socket)";
    }';
    eval 'sub SET_IRQ {
        local($f, $dip, $handler) = @_;
        eval "(*($f)-> &pcif_set_interrupt)($dip, $handler)";
    }';
    eval 'sub CLEAR_IRQ {
        local($f, $dip, $handler) = @_;
        eval "(*($f)-> &pcif_clr_interrupt)($dip, $handler)";
    }';
    eval 'sub PCCS_MAGIC {0x50434353;}';
    eval 'sub PCCS_VERSION { &_VERSION(2, 1);}';
    eval 'sub ADAPT_PROP {"adapters";}';
    eval 'sub CS_PROP {"card-services";}';
    eval 'sub DEF_DRV_PROP {"default-driver";}';
    eval 'sub PCS_CARD_PRESENT {0x0001;}';
    eval 'sub PCS_MULTI_FUNCTION {0x0002;}';
    eval 'sub PCS_ENABLED {0x0002;}';
    eval 'sub EM_EVENTSIZE {4;}';
    eval 'sub PR_WORDSIZE {8;}';
    eval 'sub PR_MASK {0x7;}';
    eval 'sub PR_GET {
        local($map, $bit) = @_;
        eval "((($map))[($bit)/ &PR_WORDSIZE] & (1 << (($bit) &  &PR_MASK)))";
    }';
    eval 'sub PR_SET {
        local($map, $bit) = @_;
        eval "((($map))[($bit)/ &PR_WORDSIZE] |= (1 << (($bit) &  &PR_MASK)))";
    }';
    eval 'sub PR_CLEAR {
        local($map, $bit) = @_;
        eval "((($map))[($bit)/ &PR_WORDSIZE] &= ~(1 << (($bit) &  &PR_MASK)))";
    }';
    eval 'sub PR_ADDR {
        local($map, $bit) = @_;
        eval "((($map)) + (($bit)/ &PR_WORDSIZE))";
    }';
    eval 'sub PR_ZERO {
        local($map) = @_;
        eval " &bzero(( &caddr_t)$map, $sizeof{$map})";
    }';
    if (defined( &i386) || defined( &__ppc)) {
	eval 'sub PR_MAX_IO_LEN {128;}';
	eval 'sub PR_MAX_IO_RANGES {8;}';
	eval 'sub PR_MAX_MEM_LEN {32;}';
	eval 'sub PR_MAX_MEM_RANGES {4;}';
    }
    eval 'sub PC_SUCCESS {1;}';
    eval 'sub PC_FAILURE {0;}';
    eval 'sub PC_MEM_AM {0;}';
    eval 'sub PC_MEM_CM {1;}';
    eval 'sub PCE_CARD_REMOVAL {0;}';
    eval 'sub PCE_CARD_INSERT {1;}';
    eval 'sub PCE_CARD_READY {2;}';
    eval 'sub PCE_CARD_BATTERY_WARN {3;}';
    eval 'sub PCE_CARD_BATTERY_DEAD {4;}';
    eval 'sub PCE_CARD_STATUS_CHANGE {5;}';
    eval 'sub PCE_CARD_WRITE_PROTECT {6;}';
    eval 'sub PCE_CARD_RESET {7;}';
    eval 'sub PCE_CARD_UNLOCK {8;}';
    eval 'sub PCE_CLIENT_INFO {9;}';
    eval 'sub PCE_EJECTION_COMPLETE {10;}';
    eval 'sub PCE_EJECTION_REQUEST {11;}';
    eval 'sub PCE_ERASE_COMPLETE {12;}';
    eval 'sub PCE_EXCLUSIVE_COMPLETE {13;}';
    eval 'sub PCE_EXCLUSIVE_REQUEST {14;}';
    eval 'sub PCE_INSERTION_COMPLETE {15;}';
    eval 'sub PCE_INSERTION_REQUEST {16;}';
    eval 'sub PCE_REGISTRATION_COMPLETE {17;}';
    eval 'sub PCE_RESET_COMPLETE {18;}';
    eval 'sub PCE_RESET_PHYSICAL {19;}';
    eval 'sub PCE_RESET_REQUEST {20;}';
    eval 'sub PCE_TIMER_EXPIRED {21;}';
    eval 'sub PCE_PM_RESUME {22;}';
    eval 'sub PCE_PM_SUSPEND {23;}';
    eval 'sub PCE_DEV_IDENT {30;}';
    eval 'sub PCE_INIT_DEV {31;}';
    eval 'sub PCE_E2M {
        local($event) = @_;
        eval "(1 << ($event))";
    }';
    eval 'sub CS_EVENT {
        local($event, $socket) = @_;
        eval "(* &pcmcia_cs_event) ($event, $socket)";
    }';
    eval 'sub PCC_MULTI {0;}';
    eval 'sub PCC_MEMORY {1;}';
    eval 'sub PCC_SERIAL {2;}';
    eval 'sub PCC_PARALLEL {3;}';
    eval 'sub PCC_FIXED_DISK {4;}';
    eval 'sub PCC_VIDEO {5;}';
    eval 'sub PCC_LAN {6;}';
    eval 'sub PCM_DEFAULT_NODEID {(-1);}';
    eval 'sub PCM_DEV_MODEL {"model";}';
    eval 'sub PCM_DEV_ACTIVE {"card-active";}';
    eval 'sub PCM_DEV_SOCKET {"socket";}';
    eval 'sub PCM_DEV_TYPE {"r2card?";}';
    eval 'sub PCMD_DEVTYPE {0x0001;}';
    eval 'sub PCMD_FUNCID {0x0002;}';
    eval 'sub PCMD_MANFID {0x0004;}';
    eval 'sub PCMD_FUNCE {0x0008;}';
    eval 'sub PCMD_VERS1 {0x0010;}';
    eval 'sub PCMD_JEDEC {0x0020;}';
    eval 'sub PCMDEV_PREFIX {"PC,";}';
    eval 'sub PCM_PROP_DEVICE {"device";}';
    eval 'sub PCM_PROP_FUNCID {"funcid";}';
    eval 'sub PCM_TYPE_MULTI {0;}';
    eval 'sub PCM_TYPE_MEMORY {1;}';
    eval 'sub PCM_TYPE_SERIAL {2;}';
    eval 'sub PCM_TYPE_PARALLEL {3;}';
    eval 'sub PCM_TYPE_FIXED {4;}';
    eval 'sub PCM_TYPE_VIDEO {5;}';
    eval 'sub PCM_TYPE_LAN {6;}';
    eval 'sub PCIOC {(ord(\'P\') << 8);}';
    eval 'sub PC_SS_CMD {
        local($cmd) = @_;
        eval "( &PCIOC|($cmd))";
    }';
    eval 'sub PCM_DEVICETYPE {"device_type";}';
    if (defined &__cplusplus) {
    }
}
1;
