if (!defined &_SYS_SMCHDW_H) {
    eval 'sub _SYS_SMCHDW_H {1;}';
    if (defined &__cplusplus) {
    }
    eval 'sub TX_BUF_LEN {(6*256);}';
    eval 'sub SEG_LEN {(1024 * 8);}';
    eval 'sub EDEVSIZ {0x20;}';
    eval 'sub SFTRST {0x80;}';
    eval 'sub MEMENA {0x40;}';
    eval 'sub ICR {1;}';
    eval 'sub ICR_585 {6;}';
    eval 'sub IRR {4;}';
    eval 'sub CCR {5;}';
    eval 'sub LAAR {5;}';
    eval 'sub UBA_STA {8;}';
    eval 'sub WD_BYTE {0xE;}';
    eval 'sub LAAR_MASK {0x1f;}';
    eval 'sub ICR_IR2 {0x04;}';
    eval 'sub ICR_EIL {0x01;}';
    eval 'sub ICR_MASK2 {0x04;}';
    eval 'sub IRR_IEN {0x80;}';
    eval 'sub IRR_IRQMASK {0x60;}';
    eval 'sub IRR_IRQ2 {0x00;}';
    eval 'sub IRR_IRQ3 {0x20;}';
    eval 'sub IRR_IRQ4 {0x40;}';
    eval 'sub IRR_IRQ7 {0x60;}';
    eval 'sub IRR_IR0 {0x20;}';
    eval 'sub IRR_IR1 {0x40;}';
    eval 'sub EIL {0x4;}';
    eval 'sub MEM16ENB {0x80;}';
    eval 'sub LAN16ENB {0x40;}';
    eval 'sub PSTART {0x1;}';
    eval 'sub PSTOP {0x2;}';
    eval 'sub BNRY {0x3;}';
    eval 'sub TPSR {0x4;}';
    eval 'sub TBCR0 {0x5;}';
    eval 'sub TBCR1 {0x6;}';
    eval 'sub ISR {0x7;}';
    eval 'sub RBCR0 {0xA;}';
    eval 'sub RBCR1 {0xB;}';
    eval 'sub RCR {0xC;}';
    eval 'sub TCR {0xD;}';
    eval 'sub DCR {0xE;}';
    eval 'sub IMR {0xF;}';
    eval 'sub RSR {0xC;}';
    eval 'sub CNTR0 {0xD;}';
    eval 'sub CNTR1 {0xE;}';
    eval 'sub CNTR2 {0xF;}';
    eval 'sub PAR0 {0x1;}';
    eval 'sub CURR {0x7;}';
    eval 'sub MAR0 {0x8;}';
    eval 'sub PAGE_0 {0x00;}';
    eval 'sub PAGE_1 {0x40;}';
    eval 'sub PAGE_2 {0x80;}';
    eval 'sub PAGE_3 {0xC0;}';
    eval 'sub PG_MSK {0x3F;}';
    eval 'sub STA {0x2;}';
    eval 'sub STP {0x1;}';
    eval 'sub TXP {0x4;}';
    eval 'sub ABR {0x20;}';
    eval 'sub PRX {0x1;}';
    eval 'sub PTX {0x2;}';
    eval 'sub RXE {0x4;}';
    eval 'sub TXE {0x8;}';
    eval 'sub OVW {0x10;}';
    eval 'sub CNT {0x20;}';
    eval 'sub RST {0x80;}';
    eval 'sub PRXE {0x1;}';
    eval 'sub PTXE {0x2;}';
    eval 'sub RXEE {0x4;}';
    eval 'sub TXEE {0x8;}';
    eval 'sub OVWE {0x10;}';
    eval 'sub CNTE {0x20;}';
    eval 'sub RDCE {0x40;}';
    eval 'sub WTS {0x1;}';
    eval 'sub BOS {0x2;}';
    eval 'sub LAS {0x4;}';
    eval 'sub BMS {0x8;}';
    eval 'sub FT0 {0x20;}';
    eval 'sub FT1 {0x40;}';
    eval 'sub CRC {0x1;}';
    eval 'sub LB0_1 {0x2;}';
    eval 'sub ATD {0x8;}';
    eval 'sub OFST {0x10;}';
    eval 'sub SEP {0x1;}';
    eval 'sub AR {0x2;}';
    eval 'sub AB {0x4;}';
    eval 'sub AM {0x8;}';
    eval 'sub PRO {0x10;}';
    eval 'sub MON {0x20;}';
    eval 'sub TSR_COL {0x4;}';
    eval 'sub TSR_ABT {0x8;}';
    eval 'sub INIT_IMR {( &PRXE +  &PTXE +  &RXEE +  &TXEE +  &OVWE +  &CNTE);}';
    eval 'sub INIT_DCR { &BMS +  &FT1;}';
    eval 'sub INIT_TCR {0;}';
    eval 'sub INIT_RCR { &AB +  &AM;}';
    eval 'sub RCRMON { &MON;}';
    eval 'sub CLR_INT {0xFF;}';
    eval 'sub NO_INT {0;}';
    eval 'sub ADDR_LEN {6;}';
    eval 'sub NETPRI { &PZERO+3;}';
    eval 'sub SYS_ENAB {0x94;}';
    eval 'sub ADAP_ENAB {0x96;}';
    eval 'sub POS_0 {0x100;}';
    eval 'sub POS_1 {0x101;}';
    eval 'sub POS_2 {0x102;}';
    eval 'sub POS_3 {0x103;}';
    eval 'sub POS_4 {0x104;}';
    eval 'sub POS_5 {0x105;}';
    eval 'sub POS_6 {0x106;}';
    eval 'sub POS_7 {0x107;}';
    eval 'sub SETUP {0x08;}';
    eval 'sub DISSETUP {0x00;}';
    eval 'sub MC_SLOTS {8;}';
    eval 'sub IDMSB {0x6F;}';
    eval 'sub IDLSBE {0xC0;}';
    eval 'sub IDLSBS {0xC1;}';
    eval 'sub IDLSBW {0xC2;}';
    eval 'sub WD_ETA_ID {(( &IDMSB << 8) |  &IDLSBE);}';
    eval 'sub WD_STA_ID {(( &IDMSB << 8) |  &IDLSBS);}';
    eval 'sub WD_WA_ID {(( &IDMSB << 8) |  &IDLSBW);}';
    eval 'sub WD_EA1_ID {0x61c8;}';
    eval 'sub WD_WA1_ID {0x61c9;}';
    eval 'sub IBM_13E_ID {0xefd5;}';
    eval 'sub IBM_13W_ID {0xefd4;}';
    eval 'sub IOBASE_594 {0x800;}';
    eval 'sub PS2_RAMSZ8 {8192;}';
    eval 'sub NUM_ID {4;}';
    eval 'sub PS2_RAMSZ {16384;}';
    eval 'sub LAN_ADDR_0 {0x08;}';
    eval 'sub LAN_ADDR_1 {0x09;}';
    eval 'sub LAN_ADDR_2 {0x0A;}';
    eval 'sub LAN_ADDR_3 {0x0B;}';
    eval 'sub LAN_ADDR_4 {0x0C;}';
    eval 'sub LAN_ADDR_5 {0x0D;}';
    eval 'sub LAN_TYPE_BYTE {0x0E;}';
    eval 'sub CHCKSM_BYTE {0x0F;}';
    eval 'sub WD_ID_BYTE0 {0x00;}';
    eval 'sub WD_ID_BYTE1 {0x00;}';
    eval 'sub WD_ID_BYTE2 {0xC0;}';
    eval 'sub REG_HWR {0x004;}';
    eval 'sub HWR_SWH {0x080;}';
    eval 'sub HWR_LPRM {0x040;}';
    eval 'sub HWR_ETHER {0x020;}';
    eval 'sub HWR_HOST16 {0x010;}';
    eval 'sub HWR_STAT2 {0x008;}';
    eval 'sub HWR_STAT1 {0x004;}';
    eval 'sub HWR_GIN2 {0x002;}';
    eval 'sub HWR_GIN1 {0x001;}';
    eval 'sub HWR_MASK {0x020;}';
    eval 'sub HWR_NUKE {0x008;}';
    eval 'sub HWR_CLR1 {0x004;}';
    eval 'sub HWR_HWCS {0x002;}';
    eval 'sub HWR_CA {0x001;}';
    if (defined &__cplusplus) {
    }
}
1;
