if (!defined &_SYS_V86_H) {
    eval 'sub _SYS_V86_H {1;}';
    require 'sys/types.ph';
    require 'sys/tss.ph';
    require 'sys/segment.ph';
    require 'sys/v86intr.ph';
    require 'sys/pcb.ph';
    require 'sys/t_lock.ph';
    if (defined &__cplusplus) {
    }
    eval 'sub V86VIRTSIZE {0x0100;}';
    eval 'sub V86WRAPSIZE {0x0010;}';
    eval 'sub V86SIZE {0x0400;}';
    eval 'sub V86EMM_PGSIZE {0x4000;}';
    eval 'sub V86EMM_LBASE {0x00200000;}';
    eval 'sub V86EMM_LENGTH {0x00200000;}';
    eval 'sub V86EMM_PBASE {0x000D0000;}';
    eval 'sub V86EMM_PBASE0 {0x000D0000;}';
    eval 'sub V86EMM_PBASE1 {0x000D4000;}';
    eval 'sub V86EMM_PBASE2 {0x000D8000;}';
    eval 'sub V86EMM_PBASE3 {0x000DC000;}';
    eval 'sub V86EMM_NUMPGS {4;}';
    eval 'sub XTSSADDR {(( &caddr_t)0x110000 &L);}';
    eval 'sub ARPL {0x63;}';
    eval 'sub V86_RCS {0xF000;}';
    eval 'sub V86_RIP {0xFFF0;}';
    eval 'sub V86_TIMER_BOUND {10;}';
    eval 'sub V86_SLICE {25;}';
    eval 'sub V86_SLICE_SHIFT {3;}';
    eval 'sub V86_PRI_NORM {0;}';
    eval 'sub V86_PRI_LO {1;}';
    eval 'sub V86_PRI_HI {2;}';
    eval 'sub V86_PRI_XHI {3;}';
    eval 'sub V86_SHIFT_NORM {0;}';
    eval 'sub V86_SHIFT_LO { &V86_SLICE_SHIFT;}';
    eval 'sub V86_SHIFT_HI { &V86_SLICE_SHIFT;}';
    eval 'sub V86FRAME {(4*4);}';
    eval 'sub V86SC_MAXARGS {3;}';
    eval 'sub V86SC_INIT {1;}';
    eval 'sub V86SC_SLEEP {2;}';
    eval 'sub V86SC_MEMFUNC {3;}';
    eval 'sub V86SC_IOPL {4;}';
    eval 'sub V86TIMER {(( &HZ*10)/182);}';
    eval 'sub V86_IMASKSIZE {256;}';
    eval 'sub V86_IMASKBITS {(( &V86_IMASKSIZE + 31) / 32);}';
    eval 'sub VP_RELCODE {2;}';
    eval 'sub EN_VTR {0x0001;}';
    eval 'sub CS_MAX {32;}';
    eval 'sub XT_MSTAT_NOPROCESS {0;}';
    eval 'sub XT_MSTAT_PROCESS {1;}';
    eval 'sub XT_MSTAT_OPSAVED {2;}';
    eval 'sub XT_MSTAT_POSTING {3;}';
    eval 'sub V86MEM_MAP {1;}';
    eval 'sub V86MEM_TRACK {2;}';
    eval 'sub V86MEM_UNTRACK {3;}';
    eval 'sub V86MEM_UNMAP {4;}';
    eval 'sub V86MEM_EMM {5;}';
    eval 'sub V86MEM_GROW {6;}';
    eval 'sub V86_MAGIC0 {ord(\'X\');}';
    eval 'sub V86_MAGIC1 {ord(\'T\');}';
    if (defined &__cplusplus) {
    }
}
1;
